/* $Id: log.h,v 1.1 2002/01/25 21:52:37 cvs Exp $ */
/*-----------------------------------------------------------------------
    Copyright (C) 2000 - Robert Banfill - All rights reserved.
-------------------------------------------------------------------------

	Message logging include file.

-----------------------------------------------------------------------*/

#if !defined _LOG_H_INCLUDED_
#define _LOG_H_INCLUDED_

#include "platform.h"

/* Constants ----------------------------------------------------------*/

#if defined HAVE_SYSLOG
#	include <syslog.h>
#else
	/* Define logging levels */
#	define LOG_EMERG	0
#	define LOG_ALERT	1
#	define LOG_CRIT		2
#	define LOG_ERR		3
#	define LOG_WARNING	4
#	define LOG_NOTICE	5
#	define LOG_INFO		6
#	define LOG_DEBUG	7
#endif

#define MAX_MESSAGE_LENGTH	256
#define LOG_FLUSH_INTERVAL	(5 * SECOND_MS)

/* Types --------------------------------------------------------------*/
#define LOG_CON			0x1
#define LOG_FIL 		0x2
#define LOG_SYS			0x4

/* Globals ------------------------------------------------------------*/

/* Prototypes ---------------------------------------------------------*/
BOOL LogOpen(CHAR *progname, CHAR *facility, CHAR *filespec);
VOID LogSetLevel(UINT8 which, UINT32 level);
UINT32 LogGetLevel(UINT8 which);

VOID LogMessage(UINT32 level, CHAR *format, ...);

VOID LogFlush(VOID);
VOID LogClose(VOID);

#endif										/* !defined _LOG_H_INCLUDED_ */
