/* $Id: config.h,v 1.9 2003/05/02 00:06:30 cvs Exp $ */
/*-----------------------------------------------------------------------
    Copyright (C) 2000 - Robert Banfill - All rights reserved.
-------------------------------------------------------------------------

    Configuration...

-----------------------------------------------------------------------*/
#if !defined _CONFIG_H_INCLUDED_
#define _CONFIG_H_INCLUDED_

#include "main.h"

/* Constants ----------------------------------------------------------*/
#define SOURCE_NONE			0
#define SOURCE_FILE			1
#define SOURCE_SOCKET		2

#define DFL_PORT		 	GRF_REGISTERED_PORT
#define DFL_FORMAT			FMT_GSE
#define DFL_LOGLEVEL 		LOG_INFO
#define DFL_LENGTH			(UST_HOUR)
#define DFL_TIMEOUT			GRF_DFL_TIMEOUT
#define DFL_ASCII_HDRS		TRUE;

/* Types --------------------------------------------------------------*/
typedef struct TAG_ARGS {
    struct {
        UINT8 type;
        CHAR name[MAX_PATH_LEN + 1];
        union {
            struct {
                ENDPOINT endpoint;
                SOCKET fd;
            } sock;
            FILE *file;
        } des;
    } src;
    UINT8 format;
    USTIME length;
    USTIME timeout;
    BOOL ascii_hdrs;
	BOOL drop_bad_times;
    CHAR name_format[MAX_PATH_LEN + 1];
    CHAR output_path[MAX_PATH_LEN + 1];
    CHAR list_file[MAX_PATH_LEN + 1];
} ARGS;

/* Macros -------------------------------------------------------------*/

/* Prototypes ---------------------------------------------------------*/
BOOL ParseCommandLine(int argc, char *argv[], ARGS * args);
VOID SetDefaults(ARGS * args);
VOID DumpConfiguration(ARGS * args);

#endif
