/* $Id: main.h,v 1.5 2003/03/22 21:16:35 cvs Exp $ */
/*-----------------------------------------------------------------------
    Copyright (C) 2000 - Robert Banfill - All rights reserved.
-------------------------------------------------------------------------

    GRFConvert main include...

-----------------------------------------------------------------------*/
#if !defined _MAIN_H_INCLUDED_
#define _MAIN_H_INCLUDED_

#include <platform.h>
#include "sock.h"
#include <grf.h>
#include "config.h"
#include "mem.h"
#include "swap.h"

#include <version.h>

/* Constants ----------------------------------------------------------*/

/* Formats that we understand */
#define FMT_NONE			0
#define FMT_ASCII			1
#define FMT_GSE				2
#define FMT_SAC				3
#define FMT_SEGY			4
#define FMT_SEED			5
#define FMT_SUDS			6
#define FMT_MATLAB			7
#define FMT_STATS			8

/* Logging levels */
#define LOG_EMERG			0
#define LOG_ALERT			1
#define LOG_CRIT			2
#define LOG_ERR				3
#define LOG_WARNING			4
#define LOG_NOTICE			5
#define LOG_INFO			6
#define LOG_DEBUG			7

/* Types --------------------------------------------------------------*/
typedef struct TAG_RECORD {
    struct TAG_RECORD *next;
    UINT32 unit;
    UINT16 channel;
    GRF_NAME name;
    GRF_TIMING timing;
    USTIME ist;
    USTIME lst;
    REAL64 rate;
    INT32 counts_per_volt;
    UINT32 n;
    INT32 *samples;
} RECORD;

typedef struct TAG_STATE {
    USTIME earliest;
    USTIME latest;
    RECORD *record;
} STATE;

/* Macros -------------------------------------------------------------*/

/* Prototypes ---------------------------------------------------------*/
CHAR *OutputFilename(RECORD *record, CHAR *net, CHAR *format, CHAR *filename);
BOOL AppendFilenameToList(CHAR *filespec);
VOID SetLogLevel(UINT32 level);
VOID LogMessage(UINT32 level, CHAR *format,...);
VOID HexDump(UINT32 loglevel, VOID *ptr, size_t length);

#endif
