/* $Id: seedtime.h,v 1.1 2001/09/24 18:43:50 cvs Exp $ */
/*-----------------------------------------------------------------------
    Copyright (C) 2001 - Robert Banfill - All rights reserved.
-------------------------------------------------------------------------

    SEED time types...

-----------------------------------------------------------------------*/
#if !defined _SEEDTIME_H_INCLUDED_
#define _SEEDTIME_H_INCLUDED_

#include "main.h"

/* Time structures ----------------------------------------------------*/

// Day of year pseudo-julian date form
typedef struct __sjtim {
    INT16 year;
    INT16 day;
    INT8 hour;
    INT8 minute;
    INT8 second;
    INT16 msec;
} STDTIME;

// Difference of a time amount
typedef struct __deltatime {
    INT32 nday;
    UINT8 nhour;
    UINT8 nmin;
    UINT8 nsec;
    UINT16 nmsecs;
} DELTA_T;

typedef INT32 JULIAN;
typedef REAL64 FLTTIME;

#define TM_MILEN  1000
#define TM_CENT   100
#define TM_DECADE 10

// Time limit (fits in 31 bits), 20 days
#define TIM_LIM (20L*86400L*1000L)

#define ST_SPAN_NIL 0                       /* No intersection */
#define ST_SPAN_ACB 1                       /* A contains B */
#define ST_SPAN_BCA 2                       /* B contains A */
#define ST_SPAN_ALB 3                       /* A less than B */
#define ST_SPAN_BLA 4                       /* B less than A */

#endif
