/* $Id: clients.h,v 1.2 2001/06/29 16:04:31 cvs Exp $ */
/*-----------------------------------------------------------------------
    Copyright (C) 2000 - Robert Banfill - All rights reserved.
-------------------------------------------------------------------------

	Client connections...

-----------------------------------------------------------------------*/
#if !defined _CLIENTS_H_INCLUDED_
#define _CLIENTS_H_INCLUDED_

#include <platform.h>
#include "sock.h"
#include <grf.h>
#include "log.h"
#include "mem.h"
#include "queues.h"

/* Constants ----------------------------------------------------------*/
#define CLI_TYPE_DATA		0				/* GRF data client */
#define CLI_TYPE_CON		1				/* Console connection */
#define CLI_TYPE_MAX		1

/* Types --------------------------------------------------------------*/
typedef struct TAG_CLIENT {
	struct TAG_CLIENT *prev;
	struct TAG_CLIENT *next;
	MUTEX mutex;
	THREAD thread_id;
	BOOL stop;
	BOOL running;
	BOOL suspended;							/* Suspended due to socket error */
	BOOL resume;
	UINT8 type;								/* Client type, CLI_TYPE_? */
	SOCKET socket;							/* Connected socket */
	ENDPOINT endpoint;						/* Client endpoint */
	UINT32 process_id;						/* Client process identifier */
	USTIME timeout;							/* Socket read/write timeout */
	H_QUEUE empties;						/* Return empties here */
	H_QUEUE queue;							/* Output queue */
} CLIENT;

/* Macros -------------------------------------------------------------*/

/* Prototypes ---------------------------------------------------------*/
BOOL ClientThreadStart(CLIENT * client);
BOOL ClientThreadStop(CLIENT * client);

#endif
