/* $Id: config.h,v 1.5 2001/10/29 22:48:45 cvs Exp $ */
/*-----------------------------------------------------------------------
    Copyright (C) 2000 - Robert Banfill - All rights reserved.
-------------------------------------------------------------------------

	Configuration...

-----------------------------------------------------------------------*/
#if !defined _CONFIG_H_INCLUDED_
#define _CONFIG_H_INCLUDED_

#include <platform.h>
#include <ustime.h>

#include "main.h"
#include "gps.h"
#include "grfthread.h"
#include "server.h"

/* Constants ----------------------------------------------------------*/
#define DFL_CONF_FILE 		"grfhub.conf"
#if defined WIN32
#   define DFL_GRF_ETC      "./"
#else
#   define DFL_GRF_ETC      "/etc/"
#endif

/* Types --------------------------------------------------------------*/
typedef struct TAG_CMDLINE_ARGS {
	BOOL daemon;
	CHAR pidfile[MAX_PATH_LEN + 1];
	BOOL verbose;
	BOOL quiet;
	BOOL debug;
	CHAR facility[MAX_PATH_LEN + 1];
	CHAR logfile[MAX_PATH_LEN + 1];
	CHAR confile[MAX_PATH_LEN + 1];
} CMDLINE_ARGS;

/* All thread arguments in one place... */
typedef struct TAG_ARGS {
	CMDLINE_ARGS cmdline;
	MAIN_ARGS main;							/* defined in main.h */
	GPS_ARGS gps;							/* defined in gps.h */
	GRF_ARGS grf;							/* defined in grfthread.h */
	SVR_ARGS server;						/* defined in server.h */
} ARGS;

/* Macros -------------------------------------------------------------*/

/* Prototypes ---------------------------------------------------------*/
BOOL Configure(ARGS * args);
BOOL DestroyLists(ARGS * args);
VOID DumpConfiguration(ARGS * args);

#endif
