/* $Id: gps.h,v 1.2 2001/06/29 16:04:31 cvs Exp $ */
/*-----------------------------------------------------------------------
    Copyright (C) 2000 - Robert Banfill - All rights reserved.
-------------------------------------------------------------------------

	GPS thread...

-----------------------------------------------------------------------*/
#if !defined _GPS_H_INCLUDED_
#define _GPS_H_INCLUDED_

#include <platform.h>
#include <async.h>
#include <ustime.h>
#include "threads.h"

/* Constants ----------------------------------------------------------*/
#define GPS_VOID_POSITION 		-32767.0
#define GPS_MAX_DEV_LEN			32

/* Defaults... */
#define GPS_DFL_BAUD			4800
#define GPS_DFL_PARITY			ASYNC_PARITY_NONE
#define GPS_DFL_DATABITS		8
#define GPS_DFL_STOPBITS		1

/* Types --------------------------------------------------------------*/
typedef struct TAG_GPS_ARGS {
	CHAR device[GPS_MAX_DEV_LEN + 1];
	UINT32 baud;
	ASYNC_PARITY parity;
	UINT8 databits;
	UINT8 stopbits;
	USTIME latency;
} GPS_ARGS;

/* Macros -------------------------------------------------------------*/

/* Prototypes ---------------------------------------------------------*/
VOID GPSSetDefaults(GPS_ARGS * args);

/* Start and stop the GPS thread... */
BOOL GPSThreadStart(GPS_ARGS * args, THREAD_LIST * threads);
BOOL GPSThreadStop(BOOL join);

/* Returns GPS lock state */
BOOL GPSIsLocked(VOID);

/* Returns last known UTC delta, UTC ~= systime + delta */
USTIME GPSGetDelta(BOOL *locked);

/* Returns last known position */
BOOL GPSGetPosition(REAL64 *latitude, REAL64 *longitude);

#endif
