/* $Id: grfthread.h,v 1.4 2001/07/12 15:37:56 cvs Exp $ */
/*-----------------------------------------------------------------------
    Copyright (C) 2000 - Robert Banfill - All rights reserved.
-------------------------------------------------------------------------

	GRF thread...

-----------------------------------------------------------------------*/
#if !defined _GRFTHREAD_H_INCLUDED_
#define _GRFTHREAD_H_INCLUDED_

#include <platform.h>
#include "sock.h"
#include <grf.h>
#include <ustime.h>
#include "threads.h"
#include "queues.h"
#include "connection.h"
#include "dst.h"
#include "master_thread.h"

/* Constants ----------------------------------------------------------*/


/* Types --------------------------------------------------------------*/
typedef struct TAG_GRF_ARGS {
	H_QUEUE empties;						/* Empty packets from clients */
	UINT8 data_type;						/* See GRF_DATA_??? constants */
	UINT16 max_samples;
	size_t con_q_depth;
	USTIME con_timeout;
	H_QUEUE con_empties;
	H_QUEUE con_input;
	CONNECTION *connections;				/* Connection list */
	DST *dst;								/* DST connections list */
    size_t n_masters;
	MASTER *master;
} GRF_ARGS;

/* Macros -------------------------------------------------------------*/

/* Prototypes ---------------------------------------------------------*/
VOID GRFSetDefaults(GRF_ARGS * args);

BOOL GRFThreadStart(GRF_ARGS * args, THREAD_LIST * threads);
BOOL GRFThreadStop(BOOL join);
BOOL GRFThreadIsRunning(VOID);

BOOL GRFRegisterClient(UINT32 host, UINT32 process, H_QUEUE queue);
BOOL GRFUnregisterClient(UINT32 host, UINT32 process);

#endif
