/* $Id: queues.h,v 1.1.1.1 2001/01/31 15:39:10 banfill Exp $" */
/*-----------------------------------------------------------------------
    Copyright (C) 2000 - Robert Banfill - All rights reserved.
-------------------------------------------------------------------------

	Generic thread safe pointer queues module.

-----------------------------------------------------------------------*/

#if !defined _QUEUES_H_INCLUDED_
#define _QUEUES_H_INCLUDED_

#include "platform.h"

/* Constants ----------------------------------------------------------*/

/* Error constants returned by functions */
#define Q_NO_ERROR				0
#define Q_EMPTY					1
#define Q_FULL					2
#define Q_ALREADY_INIT			3
#define Q_NO_INIT				4
#define Q_NO_HANDLE             5
#define Q_BAD_HANDLE			6
#define Q_NO_MEMORY				7

/* Types --------------------------------------------------------------*/
typedef UINT16 H_QUEUE;
typedef enum TAG_QUEUE_STAT {
	Q_UNUSED,								/* Returns the number of unused slots */
	Q_USED,									/* ... of used slots */
	Q_LOW,									/* ... least slots used since reset */
	Q_HIGH,									/* ... most slots used since reset */
	Q_RESET									/* Resets high and low indicators */
} QUEUE_STAT;

/* Prototypes ---------------------------------------------------------*/
UINT16 QueuesOpen(size_t n_queues);
UINT16 QueuesClose(VOID);

UINT16 QueueCreate(H_QUEUE * queue, size_t n_slots);
UINT16 QueueDestroy(H_QUEUE queue);

UINT16 QueuePut(H_QUEUE queue, VOID *ptr, BOOL block);
UINT16 QueueGet(H_QUEUE queue, VOID **ptr, BOOL block);

UINT16 QueueStat(H_QUEUE queue, QUEUE_STAT stat, INT32 *value);

CHAR *QueueErrorString(UINT16 error);

#endif
