/* $Id: server.h,v 1.4 2003/05/02 00:06:30 cvs Exp $ */
/*-----------------------------------------------------------------------
    Copyright (C) 2000 - Robert Banfill - All rights reserved.
-------------------------------------------------------------------------

	Server thread...

-----------------------------------------------------------------------*/
#if !defined _SERVER_H_INCLUDED_
#define _SERVER_H_INCLUDED_

#include <platform.h>
#include "sock.h"
#include <grf.h>
#include <ustime.h>
#include "threads.h"
#include "clients.h"
#include "repository.h"

/* Constants ----------------------------------------------------------*/
#define MAX_FRIENDLY_NAME_LEN   16

/* Defaults... */
#define DFL_PORT		 		GRF_REGISTERED_PORT
#define DFL_ADDRESS		 		INADDR_ANY

#define DFL_CONNECTIONS 	 	8
#define DFL_QUEUE_DEPTH			16

#define DFL_FRIENDLY_NAME       "GRFHub"

/* Types --------------------------------------------------------------*/
typedef struct TAG_SVR_ARGS {
	CHAR name[MAX_FRIENDLY_NAME_LEN + 1];
	H_QUEUE empties;
	ENDPOINT listen;
	HOST_LIST *allow;
	HOST_LIST *deny;
	UINT32 max_connections;
	UINT32 queue_depth;
	REPOS_ARGS repos;						/* Repository args */
} SVR_ARGS;

/* Macros -------------------------------------------------------------*/

/* Prototypes ---------------------------------------------------------*/
VOID ServerSetDefaults(SVR_ARGS * args);
BOOL ServerThreadStart(SVR_ARGS * args, THREAD_LIST * threads);
BOOL ServerThreadStop(BOOL join);
VOID DecrementConnections(VOID);
BOOL DestroyClient(CLIENT * client);


#endif
