/* $Id: threads.h,v 1.2 2001/06/29 16:04:31 cvs Exp $ */
/*-----------------------------------------------------------------------
    Copyright (C) 2000 - Robert Banfill - All rights reserved.
-------------------------------------------------------------------------

	Thread management...

-----------------------------------------------------------------------*/
#if !defined _THREADS_H_INCLUDED_
#define _THREADS_H_INCLUDED_

#include <platform.h>

/* Constants ----------------------------------------------------------*/
#define MAX_THREAD_NAME 		64

/* Types --------------------------------------------------------------*/
typedef struct TAG_THREAD_NODE {
	struct TAG_THREAD_NODE *next;
	THREAD thread_id;
	CHAR name[MAX_THREAD_NAME + 1];
} THREAD_NODE;

typedef struct TAG_THREAD_LIST {
	MUTEX mutex;
	THREAD_NODE *head;
} THREAD_LIST;

/* Prototypes ---------------------------------------------------------*/
VOID RequestShutDown(BOOL state);
BOOL ShutDownRequested(VOID);

VOID ThreadListInit(THREAD_LIST * list);
BOOL ThreadRegister(THREAD_LIST * list, THREAD thread_id, CHAR *name);
BOOL ThreadJoinAll(THREAD_LIST * list);
VOID ThreadLogAll(THREAD_LIST * list, UINT32 log_level);

#endif
