/* $Id: grfthread.h,v 1.3 2002/03/14 19:59:10 cvs Exp $ */
/*-----------------------------------------------------------------------
    Copyright (C) 2000 - Robert Banfill - All rights reserved.
-------------------------------------------------------------------------

	GRF thread...

-----------------------------------------------------------------------*/
#if !defined _GRFTHREAD_H_INCLUDED_
#define _GRFTHREAD_H_INCLUDED_

#include <platform.h>
#include "sock.h"
#include <grf.h>
#include <ustime.h>
#include "threads.h"
#include "queues.h"
#include "connection.h"
#include "trigger.h"

/* Constants ----------------------------------------------------------*/


/* Types --------------------------------------------------------------*/
typedef struct TAG_GRF_ARGS {
	H_QUEUE empties;						/* Empty packets from clients */
	size_t con_q_depth;
	USTIME con_timeout;
	H_QUEUE con_empties;
	H_QUEUE con_input;
	CONNECTION *connections;				/* Connection list */
	NETWORK *networks;						/* Network list */
} GRF_ARGS;

/* Macros -------------------------------------------------------------*/

/* Prototypes ---------------------------------------------------------*/
VOID GRFSetDefaults(GRF_ARGS * args);

BOOL GRFThreadStart(GRF_ARGS * args, THREAD_LIST * threads);
BOOL GRFThreadStop(BOOL join);
BOOL GRFThreadIsRunning(VOID);

BOOL GRFRegisterClient(UINT32 host, UINT32 process, H_QUEUE queue);
BOOL GRFUnregisterClient(UINT32 host, UINT32 process);

BOOL DistributePacket(GRF_PACKET * packet);
BOOL DistributePacketUpstream(GRF_PACKET * packet);

#endif
